﻿using System;
using System.Linq;
using System.IO;
using System.IO.IsolatedStorage;
using System.Collections.Generic;
using Microsoft.LightSwitch;
using Microsoft.LightSwitch.Framework.Client;
using Microsoft.LightSwitch.Presentation;
using Microsoft.LightSwitch.Presentation.Extensions;
using C1.Silverlight.FlexGrid;
using C1.Silverlight.Chart;
namespace LightSwitchApplication
{
    public partial class FlexibleProductSalesSetGrid
    {
        C1.Silverlight.Chart.C1Chart Chart;
        C1.Silverlight.FlexGrid.C1FlexGrid flex;

        partial void FlexibleProductSalesSetGrid_InitializeDataWorkspace(List<IDataService> saveChangesTo)
        {
            // Write your code here.
            this.ProductSalesSet.ToList().Clear();

            for (int i = 1; i <= 10; i++)
            {
                ProductSales ps = new ProductSales();
                ps.Id = i;
                ps.ProductName = "Product" + i.ToString();
                ps.Sales = i * new Random().Next(100, 2300) * 1000;

                this.ProductSalesSet.ToList().Add(ps);
            }
        }

        partial void FlexibleProductSalesSetGrid_Created()
        {
            // Write your code here.
            var _flex = this.FindControl("C1FlexGrid");
            _flex.ControlAvailable += _flex_ControlAvailable;

        }

        #region Flexgrid Events

        bool renderFlag = false;

        void _flex_ControlAvailable(object sender, ControlAvailableEventArgs e)
        {
            flex = e.Control as C1.Silverlight.FlexGrid.C1FlexGrid;
            flex.LayoutUpdated += flex_LayoutUpdated;
        }

        void flex_LayoutUpdated(object sender, EventArgs e)
        {
            var filter = C1FlexGridFilterService.GetFlexGridFilter(flex);

            if (filter != null)
                filter.FilterApplied += filter_FilterApplied;

        }

        void filter_FilterApplied(object sender, EventArgs e)
        {

            if (flex.Rows.Count > 0)
            {
                if (renderFlag)
                {
                    renderFlag = false;
                    return;
                }

                List<LightSwitchApplication.ProductSales> lst = new List<ProductSales>();
                foreach (Row rw in flex.Rows)
                {
                    if (rw.IsVisible)
                        lst.Add(rw.DataItem as LightSwitchApplication.ProductSales);
                }

                if (flex.Rows.Count >= lst.Count)
                {
                    renderFlag = true;
                    Chart.Data.ItemsSource = null;

                    Chart.BeginUpdate();
                    Chart.Data.ItemsSource = lst.AsEnumerable();
                    Chart.EndUpdate();
                }
            }

        }

        #endregion

    }
}
